{%extends 'base.html'%}
{%block content%}

<style>
    /* form errors and request messages and alerts */
.badge-light {
    margin-top: 2.5em;
}
.errorlist {
    list-style: none;
    padding-left: 0px;
    opacity: 0.8;
    color: #dc3545;
    font-size: 12px;
}
.msg {
    margin: 0 !important;
    margin-bottom: 4px !important;
    margin-top: 4px !important;
}
.messages {
    z-index: 100;
    position: fixed;
    right: 2em;
    margin-top: -1em;
    list-style: none;
    text-align: right;
}
.alert {
    margin-top: 1rem;
}
.alert-error {
    background-color: #f2dede;
    border-color: #ebcccc;
    color: #a94442;
}
</style>
<script>
    document.body.addEventListener( 'click', function (event) {
        if( event.target.className === 'unique_class_name' ) {
            const form = event.target.form;
            const data = new FormData(form);
    
            const request = new XMLHttpRequest();
            request.open(form.method, form.action, true);
            request.send(data);
    
            // logFormData(data);
           
            request.addEventListener("load", function () {
                if (this.readyState === 4 && this.status === 200) {
    
                    // catch JsonResponse from Django
                    const response = JSON.parse(this.responseText);
    
                    // display message
                    const messages = document.getElementById("messages-list");
                    messages.innerHTML += response.msg;
                    fade_alerts();
                }
            });
        }
    
    });

    // logging key-value pairs of FormData object
function logFormData(data) {
    for (const pair of data.entries()) {
        console.log(pair[0] + ": " + pair[1]);
    }
}


// fade out message alerts
function fade_alerts() {
    alerts = document.getElementsByClassName("alert msg");
        var i = alerts.length;
        for (let elem of alerts) {
            i--;
            time = 3250+(1000*i);
            setTimeout(function() {
                $(elem).fadeOut("slow");
            }, time);
        }
}

// call fade out after DOMContentLoaded
window.addEventListener('DOMContentLoaded', (event) => {
    fade_alerts();
});
</script>
    <ul>
        {%for i in form%}
        <li>{{i.name}}</li>
        {%endfor%}
    </ul>
    {% block messages %}
    <ul class="messages" id="messages-list">
    {% if messages %}
        {% for message in messages %}
        <li>
            {% if message.tags %}
                 <div class="alert alert-{{ message.tags }} msg fade show" role="alert">{{ message }}</div>
            {% else %}
                <div class="alert alert-info msg fade show" role="alert">{{ message }}</div>
            {% endif %}
        </li>
        {% endfor %}
    {% endif %}
    </ul>
{% endblock %}

{% block scripts %}
<script src="{% static 'journal/scripts/main.js' %}"></script>
{% endblock %}

{%endblock%}